package adminbenefactorhandler

import (
	"net/http"

	param "git.gocasts.ir/ebhomengo/niki/param/admin/benefactor"
	httpmsg "git.gocasts.ir/ebhomengo/niki/pkg/http_msg"
	"github.com/labstack/echo/v4"
)

// UpdateStatus godoc
// @Summary      Update benefactor status by admin
// @Description  This endpoint update status (active/inactive) benefactor.
// @Tags         Admins Benefactors
// @Accept       json
// @Produce      json
// @Param 		 id path int true "Benefactor ID"
// @Param        Request body param.BenefactorUpdateStatusRequest true "Update Benefactor Status"
// @Success      204
// @Failure      400  {string}  "Bad request"
// @Failure      401  {string}  "invalid or expired jwt"
// @Failure      403  {string}  "user not allowed"
// @Failure      404  {string}  "record not found"
// @Failure      500  {string}  "something went wrong"
// @Security 	 AuthBearerAdmin
// @Router       /admins/benefactors/{id}/status [put].
func (h Handler) UpdateStatus(c echo.Context) error {
	var req param.BenefactorUpdateStatusRequest
	if bErr := c.Bind(&req); bErr != nil {
		return echo.NewHTTPError(http.StatusBadRequest)
	}
	resp, sErr := h.benefactorSvc.UpdateStatus(c.Request().Context(), req)
	if sErr != nil {
		msg, code := httpmsg.Error(sErr)
		if resp.FieldErrors != nil {
			return c.JSON(code, echo.Map{
				"message": msg,
				"errors":  resp.FieldErrors,
			})
		}

		return echo.NewHTTPError(code, msg)
	}

	return c.JSON(http.StatusNoContent, nil)
}
